

datatype ('a, 'b) either = L of 'a | R of 'b 



(*
 * getLs : ('a, 'b) either list -> 'a list
 * REQUIRES: true
 * ENSURES: getLs lst ==> a list of all xs s.t.
 *   L x in lst, in the same relative order
 *)
fun getLs (lst:('a, 'b) either list) : 'a list =
  (case lst of 
      [] => [] 
    | (L x)::xs => x::(getLs xs)
    | _::xs => getLs xs 
  )


(*
 * getRs : ('a, 'b) either list -> 'b list
 * REQUIRES: true
 * ENSURES: getLs lst ==> a list of all xs s.t.
 *   R x in lst, in the same relative order
 *)
fun getRs (lst:('a, 'b) either list) : 'b list =
  (case lst of 
      [] => [] 
    | (R x)::xs => x::(getRs xs)
    | _::xs => getRs xs 
  )