

datatype 'a myList = NIL | CONS of 'a * 'a myList


(*
 * singleton : 'a -> 'a myList
 * REQUIRES: true
 * ENSURES: singleton x ==> a myList containing only x
 *)
fun singleton (x:'a) : 'a myList = 
  CONS (x, NIL)



(*
 * listOfMyList : 'a myList -> 'a list
 * REQUIRES: true
 * ENSURES: listOfMyList ml ==> the list 
 *  of ml's elements in the same order
 *)
fun listOfMyList (ml:'a myList) : 'a list = 
  (case ml of
      NIL => []
    | CONS (x, xs) => x::(listOfMyList xs)
  )

(*
 * myListOfList : 'a list -> 'a myList
 * REQUIRES: true
 * ENSURES: myListOfList lst ==> the myList 
 *  of lst's elements in the same order
 *)
fun myListOfList (lst:'a list) : 'a myList = 
  (case lst of 
      [] => NIL 
    | x::xs => CONS (x, myListOfList xs)
  )